<template>
    <div class="app-container">
        <div class="page-container">
            <el-form :model="queryParams" :inline="true" label-width="90">
                <el-form-item label="会员等级">
                    <el-input v-model="queryParams.name" placeholder="请输入"></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button type="primary" @click="handleQuery">查询</el-button>
                    <el-button @click="handleReset">重置</el-button>
                </el-form-item>
            </el-form>
            <el-row class="mb10">
                <el-col :span="2">
                    <el-button type="primary" @click="handleAdd">新增等级</el-button>
                </el-col>
            </el-row>
            <el-table :data="tableList">
                <el-table-column label="序号" width="55" type="index" align="center"></el-table-column>
                <el-table-column label="等级名称" prop="name" align="center"></el-table-column>
                <el-table-column label="积分范围" align="center">
                    <template #default="{ row }">
                        <span>{{ row.minPoints }} ~ {{ row.maxPoints }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="排序" prop="sort" align="center"></el-table-column>
                <el-table-column label="是否初始等级" prop="sort" align="center">
                    <template #default="{ row }">
                        <el-switch v-model="row.isInitial" :active-value="1"
                            :inactive-value="0" @change="(val)=>handleUpdateInitial(val,row)"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column label="创建时间" prop="createTime" align="center"></el-table-column>
                <el-table-column label="操作" align="center">
                    <template #default="{ row }">
                        <!-- <el-button type="text">会员权限设置</el-button> -->
                        <el-button type="text" @click="handleUpdate(row)">修改</el-button>
                        <el-button type="text" @click="handleDelete(row)">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum"
                :limit.sync="queryParams.pageSize" @pagination="getList" />
        </div>

        <!-- 表单 -->
        <form-dialog ref="formDialogRef" @handleOk="handleReset"></form-dialog>
    </div>
</template>

<script>
import { listData, setTop, delData, editInitialLevel } from '@/api/userLevel';
import FormDialog from './FormDialog.vue';
export default {
    name: 'UserLevel',
    data() {
        return {
            queryParams: {
                pageNum: 1,
                pageSize: 10
            },
            tableList: [],
            total: 0
        }
    },
    components: {
        FormDialog
    },
    created() {

    },
    mounted() {
        this.getList()
    },
    methods: {
        // 列表数据
        getList() {
            listData(this.queryParams).then(res => {
                console.log(res)
                this.tableList = res.rows;
                this.total = res.total
            })
        },
        // 新增
        handleAdd() {
            this.$refs.formDialogRef.openModal()
        },
        // 修改
        handleUpdate(row) {
            this.$refs.formDialogRef.openModal(row)
        },
        // 修改初始等级
        handleUpdateInitial(val,row){
            console.log(val,row);
            let data = {
                id:row.id,
                isInitial:val
            }
            editInitialLevel(data).then(res=>{
                this.getList()
            })
        },

        // 删除
        handleDelete(row) {
            this.$modal.confirm('确认要删除等级名称为：' + row.name + '的数据吗？').then(function () {
                return delData(row.id);
            }).then(() => {
                this.$modal.msgSuccess("删除成功");
                this.getList()
            })
        },
        // 查询
        handleQuery() {
            this.queryParams.pageNum = 1;
            this.getList()
        },
        // 重置
        handleReset() {
            this.queryParams = {
                pageNum: 1,
                pageSize: 10
            }
            this.getList()
        }
    }
}
</script>

<style lang="scss" scoped>
.app-container {
    background-color: rgba(241, 242, 247, 1);
    height: calc(100vh - 50px);

    .page-container {
        background-color: white;
        height: 100%;
        border-radius: 6px;
        padding: 20px 30px;
        box-sizing: border-box;
        overflow: auto;
    }
}
</style>
